"use strict";
exports.__esModule = true;
var nodes_1 = require("../nodes");
var getLocation_1 = require("../util/getLocation");
var mapAny_1 = require("./mapAny");
function mapParam(context, node) {
    var _a = getLocation_1["default"](context, node), line = _a.line, column = _a.column, start = _a.start, end = _a.end, raw = _a.raw;
    var param = mapAny_1["default"](context, node.name);
    if (node.value) {
        var value = mapAny_1["default"](context, node.value);
        return new nodes_1.DefaultParam(line, column, start, end, raw, param, value);
    }
    if (node.splat) {
        return new nodes_1.Rest(line, column, start, end, raw, param);
    }
    return param;
}
exports["default"] = mapParam;
