"use strict";
exports.__esModule = true;
var nodes_1 = require("decaffeinate-coffeescript2/lib/coffeescript/nodes");
var util_1 = require("util");
var isComparisonOperator_1 = require("./isComparisonOperator");
function unwindChainedComparison(node) {
    var operands = [];
    for (var link = node;;) {
        if (link instanceof nodes_1.Op && isComparisonOperator_1["default"](link)) {
            var first = link.first, second = link.second;
            if (!second) {
                throw new Error("unexpected unary operator inside chained comparison: " + util_1.inspect(node));
            }
            operands = [second].concat(operands);
            link = first;
        }
        else {
            operands = [link].concat(operands);
            break;
        }
    }
    return operands;
}
exports["default"] = unwindChainedComparison;
