import { Op } from 'decaffeinate-coffeescript2/lib/coffeescript/nodes';
import { inspect } from 'util';
import isComparisonOperator from './isComparisonOperator';
export default function unwindChainedComparison(node) {
    var operands = [];
    for (var link = node;;) {
        if (link instanceof Op && isComparisonOperator(link)) {
            var first = link.first, second = link.second;
            if (!second) {
                throw new Error("unexpected unary operator inside chained comparison: " + inspect(node));
            }
            operands = [second].concat(operands);
            link = first;
        }
        else {
            operands = [link].concat(operands);
            break;
        }
    }
    return operands;
}
